Skip to main content

## MainThreadState

# Enum MainThreadState

Source

    enum MainThreadState<'tcx> {
        GlobalCtors {
            ctor_state: GlobalCtorState<'tcx>,
            entry_id: DefId,
            entry_type: MiriEntryFnType,
            argc: ImmTy<'tcx>,
            argv: ImmTy<'tcx>,
        },
        Running,
        TlsDtors(TlsDtorsState<'tcx>),
        Yield {
            remaining: u32,
        },
        Done,
    }

Expand description

The state of the main thread. Implementation detail of `on_main_stack_empty`.

## Variants§

§

### GlobalCtors

#### Fields

§`ctor_state: GlobalCtorState<'tcx>`
§`entry_id: DefId`

The main function to call.

§`entry_type: MiriEntryFnType`
§`argc: ImmTy<'tcx>`

Arguments passed to `main`.

§`argv: ImmTy<'tcx>`
§

### Running

§

### TlsDtors(TlsDtorsState<'tcx>)

§

### Yield

#### Fields

§`remaining: u32`
§

### Done

## Implementations§

Source§

### impl<'tcx> MainThreadState<'tcx>

Source

#### fn on_main_stack_empty( &mut self, this: &mut MiriInterpCx<'tcx>, ) -> InterpResult<'tcx, Poll<()>>

## Trait Implementations§

Source§

### impl<'tcx> Debug for MainThreadState<'tcx>

Source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more

## Auto Trait Implementations§

§

### impl<'tcx> Freeze for MainThreadState<'tcx>

§

### impl<'tcx> !RefUnwindSafe for MainThreadState<'tcx>

§

### impl<'tcx> Send for MainThreadState<'tcx>

§

### impl<'tcx> Sync for MainThreadState<'tcx>

§

### impl<'tcx> Unpin for MainThreadState<'tcx>

§

### impl<'tcx> UnsafeUnpin for MainThreadState<'tcx>

§

### impl<'tcx> !UnwindSafe for MainThreadState<'tcx>

## Blanket Implementations§

Source§

### impl<T> Any for T
where T: 'static + ?Sized,

Source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
Source§

### impl<T> Borrow<T> for T
where T: ?Sized,

Source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
Source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

Source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
Source§

### impl<T> From<T> for T

Source§

#### fn from(t: T) -> T

Returns the argument unchanged.

Source§

### impl<T, U> Into<U> for T
where U: From<T>,

Source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

Source§

### impl<T> Same for T

Source§

#### type Output = T

Should always be `Self`
Source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

Source§

#### type Error = Infallible

The type returned in the event of a conversion error.
Source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
Source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

Source§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
Source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.
§

### impl<V, T> VZip<V> for T
where V: MultiLane<T>,

§

#### fn vzip(self) -> V

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 208 bytes

Size for each variant:

- `GlobalCtors`: 200 bytes
- `Running`: 0 bytes
- `TlsDtors`: 64 bytes
- `Yield`: 12 bytes
- `Done`: 0 bytes